VERSION 5.00
Begin VB.Form frmTest 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "  "
   ClientHeight    =   2910
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   3615
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2910
   ScaleWidth      =   3615
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkNoRepeat 
      Caption         =   "  "
      Height          =   195
      Left            =   540
      TabIndex        =   8
      Top             =   2580
      Width           =   2565
   End
   Begin VB.Frame Frame1 
      Caption         =   " "
      Height          =   1395
      Left            =   540
      TabIndex        =   0
      Top             =   1110
      Width           =   2565
      Begin VB.CheckBox chkModWin 
         Caption         =   "Win"
         Height          =   195
         Left            =   360
         TabIndex        =   6
         Top             =   1080
         Width           =   705
      End
      Begin VB.PictureBox picKeyCode 
         AutoRedraw      =   -1  'True
         BackColor       =   &H80000005&
         Height          =   285
         Left            =   1320
         ScaleHeight     =   225
         ScaleWidth      =   645
         TabIndex        =   5
         Top             =   690
         Width           =   705
      End
      Begin VB.CheckBox chkModAlt 
         Caption         =   "Alt"
         Height          =   195
         Left            =   360
         TabIndex        =   3
         Top             =   840
         Width           =   705
      End
      Begin VB.CheckBox chkModShift 
         Caption         =   "Shift"
         Height          =   195
         Left            =   360
         TabIndex        =   2
         Top             =   600
         Width           =   705
      End
      Begin VB.CheckBox chkModCtrl 
         Caption         =   "Ctrl"
         Height          =   195
         Left            =   360
         TabIndex        =   1
         Top             =   360
         Width           =   705
      End
      Begin VB.Label Label1 
         Caption         =   "+"
         Height          =   195
         Left            =   1140
         TabIndex        =   4
         Top             =   720
         Width           =   165
      End
   End
   Begin VB.Label lblTime 
      Alignment       =   2  '
      Caption         =   "   ,      ,       ."
      Height          =   855
      Left            =   330
      TabIndex        =   7
      Top             =   120
      Width           =   2955
   End
End
Attribute VB_Name = "frmTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const MOD_ALT      As Long = &H1
Const MOD_CONTROL  As Long = &H2
Const MOD_NOREPEAT As Long = &H4000
Const MOD_SHIFT    As Long = &H4
Const MOD_WIN      As Long = &H8

Const GWL_WNDPROC  As Long = -4


Private Declare Function RegisterHotKey Lib "user32" (ByVal hWnd As Long, ByVal id As Long, ByVal fsModifiers As Long, ByVal vk As Long) As Long
Private Declare Function UnregisterHotKey Lib "user32" (ByVal hWnd As Long, ByVal id As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long


Const KEYBINDING_ID     As Long = 1

Dim blnCtrlModificator  As Boolean
Dim blnShiftModificator As Boolean
Dim blnAltModificator   As Boolean
Dim blnWinModificator   As Boolean
Dim blnCatchOnce        As Boolean

Dim intVirtKey          As Integer



Private Sub UpdateKeyBindings()
    UnregisterHotKey hWnd, KEYBINDING_ID
    If RegisterHotKey(hWnd, KEYBINDING_ID, (blnAltModificator And MOD_ALT) Or _
                                           (blnCtrlModificator And MOD_CONTROL) Or _
                                           (blnCatchOnce And MOD_NOREPEAT) Or _
                                           (blnShiftModificator And MOD_SHIFT) Or _
                                           (blnWinModificator And MOD_WIN), _
 _
                      intVirtKey) = 0 Then MsgBox "    .", vbCritical
End Sub

Private Sub UpdateKeyCodeField()
    picKeyCode.Cls
    picKeyCode.CurrentX = 10
    picKeyCode.CurrentY = 10
    picKeyCode.Print (intVirtKey)
End Sub



Private Sub Form_Load()
    lngNativeWndProc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf OurWndProc)
    
    blnCtrlModificator = True
    chkModCtrl.Value = vbChecked
    
    intVirtKey = 83 '( S)
    UpdateKeyCodeField
    
    UpdateKeyBindings
End Sub

Private Sub Form_Unload(Cancel As Integer)
    UnregisterHotKey hWnd, KEYBINDING_ID
End Sub



Private Sub chkModCtrl_Click()
    blnCtrlModificator = chkModCtrl.Value = vbChecked
    UpdateKeyBindings
End Sub

Private Sub chkModShift_Click()
    blnCtrlModificator = chkModShift.Value = vbChecked
    UpdateKeyBindings
End Sub

Private Sub chkModAlt_Click()
    blnCtrlModificator = chkModAlt.Value = vbChecked
    UpdateKeyBindings
End Sub

Private Sub chkModWin_Click()
    blnCtrlModificator = chkModWin.Value = vbChecked
    UpdateKeyBindings
End Sub

Private Sub chkNoRepeat_Click()
    blnCatchOnce = chkNoRepeat.Value = vbChecked
    UpdateKeyBindings
End Sub



Private Sub picKeyCode_GotFocus()
    picKeyCode.BackColor = vbYellow
End Sub

Private Sub picKeyCode_KeyUp(KeyCode As Integer, Shift As Integer)
    'Ctrl, Shift, Alt, Win
    If (KeyCode < 16 Or KeyCode > 18) And KeyCode <> 91 Then
        intVirtKey = KeyCode
    End If
    
    UpdateKeyBindings
    
    UpdateKeyCodeField
End Sub

Private Sub picKeyCode_LostFocus()
    picKeyCode.BackColor = vbWindowBackground
    UpdateKeyCodeField
End Sub
